HDU 1069 (DP)

Problem Description

A group of researchers are designing an experiment to test the IQ of a monkey. They will hang a banana at the roof of a building, and at the mean time, provide the monkey with some blocks. If the monkey is clever enough, it shall be able to reach the banana by placing one block on the top another to build a tower and climb up to get its favorite food.

The researchers have n types of blocks, and an unlimited supply of blocks of each type. Each type-i block was a rectangular solid with linear dimensions (xi, yi, zi). A block could be reoriented so that any two of its three dimensions determined the dimensions of the base and the other dimension was the height. 

They want to make sure that the tallest tower possible by stacking blocks can reach the roof. The problem is that, in building a tower, one block could only be placed on top of another block as long as the two base dimensions of the upper block were both strictly smaller than the corresponding base dimensions of the lower block because there has to be some space for the monkey to step on. This meant, for example, that blocks oriented to have equal-sized bases couldn't be stacked. 

Your job is to write a program that determines the height of the tallest tower the monkey can build with a given set of blocks.
 

Input
The input file will contain one or more test cases. The first line of each test case contains an integer n,
representing the number of different blocks in the following data set. The maximum value for n is 30.
Each of the next n lines contains three integers representing the values xi, yi and zi.
Input is terminated by a value of zero (0) for n.
 

Output
For each test case, print one line containing the case number (they are numbered sequentially starting from 1) and the height of the tallest possible tower in the format "Case case: maximum height = height".
 

Sample Input
1 10 20 30 2 6 8 10 5 5 5 7 1 1 1 2 2 2 3 3 3 4 4 4 5 5 5 6 6 6 7 7 7 5 31 41 59 26 53 58 97 93 23 84 62 64 33 83 27 0
 

Sample Output
Case 1: maximum height = 40 Case 2: maximum height = 21 Case 3: maximum height = 28 Case 4: maximum height = 342


題意:給你n種方塊,每種方塊數量不限,方塊可以翻轉,求能夠疊到的最大高度。但是要求每一層放的方塊長和寬都要比它上面的那一層大,所以可以得到每種方塊最多也就會用到3次。分別以x,y,z爲高,因爲長和寬可以互換,所以每種方塊共有3*2種擺放的姿勢。


解題思路:把每種方塊可能的擺放情況全部羅列出來,再按照x從大到小,y從大到小的方式排序,然後LIS就可以了。


具體代碼如下:


#include <iostream>
#include <cstdio>
#include <cstring>
#include <algorithm>

using namespace std;

struct node
{
    int x;
    int y;
    int z;
} dp[210];

int cmp(node xi,node yi)
{
    if(xi.x!=yi.x)
        return xi.x>yi.x;
    if(xi.y!=yi.y)
        return xi.y>yi.y;
    return 1;
}

int main()
{
    int a,b,c,n,count1=1;
    while(~scanf("%d",&n)&&n)
    {
        for(int i=0; i<n; i++)
        {
            int k=i*6;
            scanf("%d %d %d",&a,&b,&c);
            dp[k].x=a;
            dp[k].y=b;
            dp[k].z=c;
            k++;
            dp[k].x=b;
            dp[k].y=a;
            dp[k].z=c;
            k++;
            dp[k].x=a;
            dp[k].y=c;
            dp[k].z=b;
            k++;
            dp[k].x=c;
            dp[k].y=a;
            dp[k].z=b;
            k++;
            dp[k].x=b;
            dp[k].y=c;
            dp[k].z=a;
            k++;
            dp[k].x=c;
            dp[k].y=b;
            dp[k].z=a;
            k++;
        }
        sort(dp,dp+n*6,cmp);
        int maxi=0,h;
        for(int i=1; i<n*6; i++)
        {
            h=0;
            for(int j=0; j<i; j++)
            {
                if((dp[i].x<dp[j].x&&dp[i].y<dp[j].y)||(dp[i].x<dp[j].y&&dp[i].y<dp[j].x))  //找出前面最大的。
                    h=max(h,dp[j].z);
            }
            dp[i].z+=h;
            maxi=max(maxi,dp[i].z);
        }
        printf("Case %d: maximum height = %d\n",count1++,maxi);
    }
    return 0;
}




發表評論
所有評論
還沒有人評論,想成為第一個評論的人麼? 請在上方評論欄輸入並且點擊發布.
相關文章